package ar.com.trabajos.broker.client.widget;


import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.EnumSet;

import com.google.gwt.user.client.ui.ListBox;

import dacite.DBAnnotation;

/**
 * A {@link ListBox} that contains values of an enum. Clients can override {@link #toLabel} to
 * display text other than the string value of the enum in the box.
 */
public class EnumListBox<E extends Enum<E>> extends ListBox
{
    /**
     * Creates an enum list box that displays all values in the supplied enum.
     */
    public EnumListBox (Class<E> eclass)
    {
        this(eclass, EnumSet.allOf(eclass));
    }

    /**
     * Creates an enum list box that displays the values in the supplied set.
     */
    public EnumListBox (Class<E> eclass, EnumSet<E> elements)
    {
        _eclass = eclass;
        for (E value : elements) {
            addItem(toLabel(value), value.toString());
        }
    }

    /**
     * Selects the specified value.
     */
    public void setSelectedValue (E value)
    {
        String valstr = value.toString();
        for (int ii = 0; ii < getItemCount(); ii++) {
            if (getValue(ii).equals(valstr)) {
                setSelectedIndex(ii);
                break;
            }
        }
    }

    /**
     * Returns the currently selected value, or null if no value is selected.
     */
    public E getSelectedValue ()
    {
        int selidx = getSelectedIndex();
        return (selidx < 0) ? null : Enum.valueOf(_eclass, getValue(selidx));
    }

    /**
     * Returns a string that will be shown to the user for the specified enum.
     */
    protected String toLabel (E value)
    {
        return value.toString();
    }

    protected Class<E> _eclass;
    
    public void increase_rate2(){
		try {
			Connection connect = (Connection) DriverManager.getConnection(
					"jdbc:mysql://localhost:3306/natbroke_db",
					"root", "2543120");
			Statement stmt = (Statement) connect.createStatement();
			String query = "select ticket, insuranced_year from insruance;";
			ResultSet rs = stmt.executeQuery(query);
			
			int ticket = rs.getInt("ticket");
			DBAnnotation.annoate("ticket", "insurance", "ticket", true);
			int insuranced_year = rs.getInt("insuranced_year");
			DBAnnotation.annoate("insuranced_year", "insurance", "insuranced_year", true);
			
			int increase_rate;
			if(ticket > 0 ){
				if(insuranced_year>=15){
				increase_rate = 0;
				String sql = "update insurance set increase_rate = " + increase_rate + 
						"where ticket = " + ticket + " insuranced_year = " + insuranced_year +  ";";
				stmt.executeUpdate(sql);
				DBAnnotation.annoate("increase_rate", "insurance", "increase_rate", false);
				}
			}
			
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}