package ar.com.trabajos.broker.server.service;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import javax.xml.ws.WebServiceException;
import javax.xml.ws.soap.SOAPFaultException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import ar.com.elcomercio.ws.CotizacionesWS;
import ar.com.elcomercio.ws.ESBException_Exception;
import ar.com.elcomercio.ws.MalformedResponseException_Exception;
import ar.com.elcomercio.ws.RPCException_Exception;
import ar.com.elcomercio.ws.ServiceException_Exception;
import ar.com.trabajos.broker.server.dao.AppDAO;
import ar.com.trabajos.broker.shared.entities.RequestDTO;
import ar.com.trabajos.broker.shared.entities.ResponseDTO;
import ar.com.trabajos.broker.shared.enums.BrokerEnum;

public class ObtenerCotizacionElComercio implements Cotizador {
	private static Log log = LogFactory.getLog(ObtenerCotizacionElComercio.class);
	private boolean primerIntento= true;
	
	public ResponseDTO cotizar(RequestDTO input){
		
		ResponseDTO response=null;
		CotizacionesWS ws;
		try {
			AppDAO dao = new AppDAO();
			try {
				ws = new CotizacionesWS();
			}catch (WebServiceException e){
				response =	new ResponseDTO();	
				response.setBroker(BrokerEnum.ELCOMERCIO);
				response.setError("Error intentando conectarse a el comercio");
				return response;
			}
			//TODO Revisar lugar de storage de esto
			String usuario = "na17795";
			String password = "19238";
			//Asume fecha de hoy
			SimpleDateFormat formateador = new SimpleDateFormat("dd/MM/yyyy");
			String fechaDesde = formateador.format(new Date());
			//Asume tarifacion mensual
			String codTarifacion="12";
			String codPlanPago="T01";
			//Asume condicion de iva Consumidor final
			String condIva="4";
			//Se asume codTVeh
			String codTVeh = "110";
			//Se asume persona fisica
			String tipoPersona = "F";
			//Se asume prima variable 9, el ws responde que varia entre 9 y 68.
			String primaVariable= "9";
			//Se asume clausula de ajuste 0 , ver xls
			String clausulaAjuste="0";
			//Se asume sumagranizo = 0 por lo pronto
			String sumaGranizo="0";		
			
			//Se manda 1(0) + tabla infoauto		
			String marca;
			if (input.getCodInfoAuto().length()==5){
				 marca = "10" + input.getCodInfoAuto();
			}else
				marca = "1" + input.getCodInfoAuto();
			Calendar cal = Calendar.getInstance();
			
			String marca0KM;
			if (Integer.parseInt(input.getModelo())>=cal.get(Calendar.YEAR))
				marca0KM="1";
			else
				marca0KM="0";

			//Se asume sumaGNC = 0
			String sumaGNC="0";
			
			int codUso = dao.obtenerCodigoUso(input.getTipoUso(), input.getBroker());
			int codProv = dao.obtenerCodigoProvincia(input.getProvincia(), input.getBroker());
			int codZona = dao.obtenerCodigoZonaElCom(input.getCodigoPostal());
			//Llamado al servicio
			String result= ws.getCotizacionesWSHttpSoap11Endpoint().getStrCotizacion(usuario, password, marca, 
					input.getModelo(), fechaDesde, codTarifacion, Integer.toString(codProv), Integer.toString(codZona), condIva, marca0KM, Integer.toString(codUso), codPlanPago, 
					input.getSumaAsegurada(), sumaGNC, primaVariable, clausulaAjuste, sumaGranizo, codTVeh, 
					tipoPersona);
			response = DigesterDriver.digestElComercioResponse(result);	
			response.setBroker(BrokerEnum.ELCOMERCIO);
			
			//Comienzo del pedido dos, con granizo
			sumaGranizo="5000";
			result= ws.getCotizacionesWSHttpSoap11Endpoint().getStrCotizacion(usuario, password, marca, 
					input.getModelo(), fechaDesde, codTarifacion, Integer.toString(codProv), Integer.toString(codZona), condIva, marca0KM, Integer.toString(codUso), codPlanPago, 
					input.getSumaAsegurada(), sumaGNC, primaVariable, clausulaAjuste, sumaGranizo, codTVeh, 
					tipoPersona);
			ResponseDTO response2 = DigesterDriver.digestElComercioResponse(result);
			if (response2.getTc()!=0)
				response.setTc(response2.getTc());
			//Atencion a las siglas
			if (response2.getTcf()!=0)
				response.setTcfg(response2.getTcf());
			if (response2.getTr()!=0)
				response.setTr(response2.getTr());
			//fin pedido dos
		} catch (ESBException_Exception e) {
			log.error("El comercio fallo con: " + e.getMessage());
		} catch (MalformedResponseException_Exception e) {
			log.error("El comercio fallo con: " + e.getMessage());
		} catch (RPCException_Exception e) {
			log.error("El comercio fallo con: " + e.getMessage());
		} catch (ServiceException_Exception e) {
			log.error("El comercio fallo con: " + e.getMessage());
		} catch (SOAPFaultException e) {
			
			response = new ResponseDTO();
			response.setBroker(BrokerEnum.ELCOMERCIO);
			response.setError(e.getMessage());
			
			if (!primerIntento){				
				log.error("El comercio segundo intento fallo con: " + e.getMessage());
			}else
				log.error("El comercio primer intento fallo con: " + e.getMessage());
			
			if (e.getMessage().contains("prolog") && primerIntento){
				primerIntento=false;
				return this.cotizar(input);
			}
		}
		
		return response;
		
	}
}
